#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "proto.h" 

double det_gauss(double **a,int n)
{ 
  int i,k;
  double det;

  for(k=0; k<n; k++) {
    for(i=k+1; i<n; i++) {
      xpay(a[i]+k,-a[i][k]/a[k][k],a[k]+k,n-k);
    }
  }

  det = a[0][0];
  for(i=1; i<n; i++)
    det *= a[i][i]; 

  return det;
}

int main() {
  int n,i,j;
  double **a;

  scanf("%d",&n);
  a = matrix(n,n);
  if ( a == NULL) 
    error_exit("Out of memory",__FILE__,__LINE__);
  
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      scanf("%lf",&a[i][j]);
  print_mat(a,n); printf("\n");

  printf("Laplace: |A|=%g\n\n",det(a,n));
  printf("Gauss  : |A|=%g\n\n",det_gauss(a,n));

  print_mat(a,n); printf("\n");

  free_matrix(a,n,n);
}
 
